﻿using EJGrid.Models;
using Microsoft.OData.Edm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.OData.Batch;
using System.Web.OData.Builder;
using System.Web.OData.Extensions;

namespace EJGrid
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            HttpServer server = new HttpServer(config);
            IEdmModel model;
            using (EnumDBContext context = new EnumDBContext())
            {
                model = GetModel();
            }
            config.MapHttpAttributeRoutes();
            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "odata/{controller}/{action}/{id}",  //if you are using odata controller
                defaults: new { id = RouteParameter.Optional }
            );
            // Create our batch handler and associate it with the OData service.
            ODataBatchHandler batchHandler = new DefaultODataBatchHandler(GlobalConfiguration.DefaultServer);

            config.MapODataServiceRoute("odata", "odata", model, batchHandler);
            config.EnableEnumPrefixFree(enumPrefixFree: true);
            config.EnsureInitialized();

        }
        public static Microsoft.OData.Edm.IEdmModel GetModel()
        {
            ODataModelBuilder builder = new ODataConventionModelBuilder();

            var order = builder.EntitySet<Program1>("Orders");
            FunctionConfiguration myFirstFunction = order.EntityType.Collection.Function("MyFirstFunction");
            myFirstFunction.ReturnsCollectionFromEntitySet<Program1>("Orders");

            return builder.GetEdmModel();
        }
    }


}
